<?php

// Adding Meta container in admin shop_order pages
add_action('add_meta_boxes', 'chabock_add_meta_boxes');
function chabock_add_meta_boxes()
{
    add_meta_box(
        'chabock_add_meta_boxes',
        'ارسال سفارش به روش چابک',
        // __('ارسال سفارش به روش چابک', 'woocommerce'),
        'chabock_fields_for_packaging',
        'shop_order',
        'normal',
        'high'
    );

}

function chabock_fields_for_packaging($post)
{
    global $woocommerce, $post, $current_user;
    $order_id = intval($post->ID);

    if(!get_post_meta($order_id, 'order_tracking_chabok', true)){
        
        $order = wc_get_order($order_id);
        $order_data = $order->get_data();
   
        $reference = $order_id . '111' . rand(99, 999);
        $date = $order_data['date_created']->date('Y-m-d');
        $order_total = $order_data['total'];
        
        //wc_chabok_price_currency = 1 is ریال
        $value = get_option('wc_chabok_price_currency') == '1' ? $order_total : $order_total*10;;
        $person = $order_data['billing']['first_name'] . ' ' . $order_data['billing']['last_name'];
        $city_no = $order_data['billing']['city'];
        $mobile = $order_data['billing']['phone'];
        $email = $order_data['billing']['email'];
        $address = $order_data['billing']['address_1'];
        $postcode = $order_data['billing']['postcode'];

        $order_items  = $order->get_items();
        $total_qty    = 0;
        $total_weight = 0;
        $categories = '';
        foreach ($order_items as $item_id => $product_item) {
            $product_id    = $product_item['product_id'];
            $product = wc_get_product($product_id);
            if (!$product) continue;
            $product_weight  = $product->get_weight() ? $product->get_weight() : 1;
            $quantity        = $product_item->get_quantity();
            $total_qty      += $quantity;
            $total_weight   += floatval($product_weight * $quantity);
            $terms = get_the_terms($product->get_id(), 'product_cat');

            $categories .= reset($terms)->name . ' / ';
        }

        //wc_chabok_weight_unit = 1 is کیلوگرم
        $weight =  get_option('wc_chabok_weight_unit') == '1' ? $total_weight : $total_weight/1000;
        $content = $categories;

        if(get_option('wc_chabok_services')=='0'){
            $service="1";
        }elseif(get_option('wc_chabok_services')=='1'){
            $service="6";
        }elseif(get_option('wc_chabok_services')=='2'){
            $service="35";
        }

        if(get_option('wc_chabok_delivery_only_teh') == 'no'){
            ?>
            <form style="padding: 10px;" method="POST">
                <input type="text" id="order_cod" name="order_cod" placeholder="مبلغ cod را وارد  کنید" />
                <input type="text" id="order_weight" name="order_weight" placeholder="وزن اقلام رابه کیلوگرم وارد کنید" />
                <input type="hidden" name="order_id" value="<?php echo $order_id; ?>" />
                <input type="hidden" name="reference" value="<?php echo $reference; ?>" />
                <input type="hidden" name="date" value="<?php echo $date; ?>" />
                <input type="hidden" name="value" value="<?php echo $value; ?>" />
                <input type="hidden" name="person" value="<?php echo $person; ?>" />
                <input type="hidden" name="city_no" value="<?php echo $city_no; ?>" />
                <input type="hidden" name="mobile" value="<?php echo $mobile; ?>" />
                <input type="hidden" name="email" value="<?php echo $email; ?>" />
                <input type="hidden" name="address" value="<?php echo $address; ?>" />
                <input type="hidden" name="postcode" value="<?php echo $postcode; ?>" />
                <input type="hidden" name="weight" value="<?php echo $weight; ?>" />
                <input type="hidden" name="content" value="<?php echo $content; ?>" />
                <input type="hidden" name="service" value="<?php echo $service; ?>" />
                <input type="submit" class="button-primary" name="add_chabock" id="validate-submit-chabock" value="صدور بارنامه چابک" style="background: green;">
            </form>
            <?php
        }else{
            if ( $city_no  === 'تهران'){
                ?>
                <form method="POST">
                    <input type="text" id="order_cod" name="order_cod" placeholder="مبلغ cod را وارد  کنید" />
                    <input type="text" id="order_weight" name="order_weight" placeholder="وزن اقلام رابه کیلوگرم وارد کنید" />
                    <input type="hidden" name="order_id" value="<?php echo $order_id; ?>" />
                    <input type="hidden" name="reference" value="<?php echo $reference; ?>" />
                    <input type="hidden" name="date" value="<?php echo $date; ?>" />
                    <input type="hidden" name="value" value="<?php echo $value; ?>" />
                    <input type="hidden" name="person" value="<?php echo $person; ?>" />
                    <input type="hidden" name="city_no" value="<?php echo $city_no; ?>" />
                    <input type="hidden" name="mobile" value="<?php echo $mobile; ?>" />
                    <input type="hidden" name="email" value="<?php echo $email; ?>" />
                    <input type="hidden" name="address" value="<?php echo $address; ?>" />
                    <input type="hidden" name="postcode" value="<?php echo $postcode; ?>" />
                    <input type="hidden" name="weight" value="<?php echo $weight; ?>" />   
                    <input type="hidden" name="content" value="<?php echo $content; ?>" />
                    <input type="hidden" name="service" value="<?php echo $service; ?>" />
                    <input type="submit" class="button-primary" name="add_chabock" id="validate-submit-chabock" value="صدور بارنامه چابک" style="background: green;">
                </form>
                <?php
            }else{
                echo '<table class="sending_orders_table remove" style="width:100%">
                <tr>
                <th>پیام</th>
                </tr>
                <tr> روش ارسال چابک تنها درمناطق 22 گانه تهرن فعال است. برای فعال کردن سایر شهرها به بخش تنظیمات چابک بروید.!</td>
                </tr>
                </table>';
            }
        }
    }//end if add meta box when barcode is null
}

function add_chabock_form_function()
{    

    if (isset($_POST['add_chabock'])) {
        
        $cod = (isset($_POST['order_cod']) && !empty($_POST['order_cod'])) ? intval(trim($_POST['order_cod'])) : 0;
        $weight = (isset($_POST['order_weight']) && !empty($_POST['order_weight'])) ? intval(trim($_POST['order_weight'])) : $_POST['weight'];

		$api=get_option('wc_chabok_api', 'https://api.krch.ir/v1');
        $username = get_option('wc_chabok_username');
        $password = get_option('wc_chabok_password');
        $storename = get_option('wc_chabok_storename');
        $storeemail = get_option('wc_chabok_storeemail');
        $storecity = find_city_chabok(get_option('wc_chabok_store_city_name'));
        $usertell = get_option('wc_chabok_usertell');
        $store_address = get_option('wc_chabok_store_address');

        $order_id = $_POST['order_id'];
        $reference = $_POST['reference'];
        $date = $_POST['date'];
        $service = $_POST['service'];
        $value =  $_POST['value'];
        $person = $_POST['person'];
        $city = $_POST['city_no'];
        $mobile =  $_POST['mobile'];
        $email =  $_POST['email'];
        $address =  $_POST['address'];
        $postcode =  $_POST['postcode'];
        $content =  $_POST['content'];

        $city_no = find_city_chabok($city);

        $user = new stdClass();
        $user->username = $username;
        $user->password = $password;

        $cn = new stdClass();
        $cn->reference = $reference;
        $cn->date = $date;
        $cn->assinged_pieces = 1;
        $cn->service = $service;
        $cn->value = $value;
        $cn->payment_term = 0;
        $cn->weight = $weight;  
        $cn->content = $content;   
        $cn->note = '';
        $cn->inv_value = 0;

        $sender = new stdClass();
        $sender->person = $storename;
        $sender->company = $storename;
        $sender->city_no = $storecity;
        $sender->telephone = $usertell;
        $sender->mobile = $usertell;
        $sender->email = $storeemail;
        $sender->address = $store_address;

        $receiver = new stdClass();
        $receiver->person = $person;
        $receiver->city_no = $city_no;
        $receiver->telephone = $mobile;
        $receiver->mobile = $mobile;
        $receiver->email = $email;
        $receiver->address = $address;
        $receiver->postcode = $postcode;

        $bulk = array();
        $bulkItem = new stdClass();
        $bulkItem->cn = $cn;
        $bulkItem->sender = $sender;
        $bulkItem->receiver = $receiver;
        $bulk[] = $bulkItem;
  
        $data = new stdClass();
        $data->user = $user;
        $data->bulk = $bulk;  

        $json_data = json_encode($data);

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $api."/bulk_import",
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => array('input' => $json_data),
			CURLOPT_HTTPHEADER => array(
				'Content-Type: multipart/form-data'
			)
        ));

		$response = curl_exec($curl);
		$error = curl_error($curl);
		$status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		curl_close($curl);

		if ($error && $status_code !== 200) {
			var_dump($error);  
			return false;
		} else {

			$result = json_decode($response, true);
			if($result['result']){
				$tracking = $result["objects"]["result"][0]["tracking"];
				update_post_meta($order_id, 'order_tracking_chabok', $tracking);
				update_post_meta($order_id, 'puiw_invoice_track_id', $tracking);
				update_post_meta($order_id, 'order_result_chabok', 'true');
			}else{
				$msg = $result['message'];
				update_post_meta($order_id, 'order_tracking_massage',  $msg );
				update_post_meta($order_id, 'order_result_chabok', 'false');
			}

		}
		
		header("location:" . $_SERVER['HTTP_REFERER']);
		exit();
	}

}

add_chabock_form_function();

function find_city_chabok($city_name)
{
    $folder_path = dirname(__FILE__);
    $json_file_path = $folder_path . '/city.json';
    $request = file_get_contents($json_file_path);
    $request_array = json_decode($request, true);
    $cites = $request_array['objects']['city'];
    $city_col = array_search($city_name, array_column($cites, 'name'));
    return $cites[$city_col]['no'];
}

function show_tracking_code_or_massage_chabok_order($order)
{
    $order_id = $order->get_id();
    global $PeproUltimateInvoice;
    $generator = $PeproUltimateInvoice->barcode;

    if (get_post_meta($order_id, 'order_tracking_chabok', true)) {
        if (is_plugin_active('pepro-ultimate-invoice/pepro-ultimate-invoice.php')) {
            $src = 'data:image/jpeg;base64,' . base64_encode($generator->getBarcode(get_post_meta($order_id, 'order_tracking_chabok', true), $generator::TYPE_CODE_128));
            echo '<strong>شماره بارنامه</strong><img alt="" class="barcode" style="width:150px;height:auto;display:block" src="' . $src . '"><span style="text-align:center">' . get_post_meta($order_id, 'order_tracking_chabok', true) . '</span>';
        } else {
            echo ' <strong>شماره بارنامه</strong>
                    <span style="text-align:center">' . get_post_meta($order_id, 'order_tracking_chabok', true) . '</span>';
        }
    }

    if (get_post_meta($order_id, 'order_tracking_massage', true)) {
        echo '<div style="    
                    background: red;
                    padding: 10px;
                    color: #000;
                    font-size: 15px;
                    line-height: 20px;">
                <strong> بارنامه چابک دریافت نشد!</strong></br>
                <span style="text-align:center">متن خطا: ' . get_post_meta($order_id, 'order_tracking_massage', true) . '</span></div>';
    }
}
// add_action('woocommerce_admin_order_data_after_billing_address', 'show_tracking_code_or_massage_chabok_order', 10, 1);

